/*
		JAS v1.00							  (c) 1996 NikSoft International
		--------------------------------------------------------------------
		BPATCH.H

		Header file for backpatch module.

		Thursday, January 02, 1997	Version 1.00
		Thursday, February 20, 1997
			The original project is now called JAS The Jet ASsembler,
			simply because I like more this name!
		Saturday, May 10, 1997
			Added support for EXTOP backpatching.
*/


#ifndef __BPATCH_H
#define __BPATCH_H

#include "ptypes.h"

typedef struct patch {
	union {
	    INSN    __istruction; /* Istruction to be patched */
		struct {
			long __segment;
			long __offset;
		}		__data_info;
	}		__patch_data;
	long	Seg;		/* Its segment ... */
	long	Offset;		/* ... and offset */
	short	Bits;		/* Bits of the code to be generated */
	short	RefCount;	/* Number of PATCHREFs that refere to this PATCH */
} PATCH;

#define patch_instr			__patch_data.__istruction
#define patch_seg			__patch_data.__data_info.__segment
#define patch_off			__patch_data.__data_info.__offset

typedef struct patchref {
	struct patch	*ThePatch;	/* Istruction to patched */
	short	        PatchType;	/* Type of the refence (istruction operand
						           or simple offset) */
	long			Offset;
	long			Occur;
	struct patchref *Prev, *Next;
} PATCHREF;

extern void AddPatchRef(struct symbol *, PATCH *, short, long);
extern void BPatch(struct symbol *);
extern int	UndefSymNum();

#endif
/* -------- End Of File ----------------------------------------------- */
