/*
		JAS v1.00							  (c) 1997 NikSoft International
		--------------------------------------------------------------------
		JASLIB.H

		Header file for Library functions module.

		Saturday, November 30, 1996 Version 1.00
*/


#ifndef __JASLIB_H
#define __JASLIB_H

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

enum modes {
	M_RDBIN= 0,
	M_RWBIN,
	M_RDTEXT,
	M_RWTEXT,

	MAXMODE
};

extern void *LIB_malloc(size_t);
extern void *LIB_realloc(void *, size_t);
extern void LIB_free(void *);

extern int	LIB_setflags(int);
extern long seg_alloc();

extern char *LIB_strdup(char *);
extern char *LIB_strcat(char *, char *);
extern char *LIB_StrToUpper(char *, char *);
extern int	LIB_stricmp(const char *, const char *);
extern int	LIB_strnicmp(const char *, const char *, int);
extern int	LIB_readnum(char *);
extern char *LIB_addExtension(char *, char *, char *);

extern FILE *LIB_fopen(char *, int);
extern int	LIB_fclose(FILE *, int);

/* some handy macros that will probably be of use in more than one
   output format: convert integers into little-endian byte packed
   format in memory */

#define WRITELONG(p,v) \
  do { \
	*(unsigned char *)(p)++ = (v) & 0xFF; \
	*(unsigned char *)(p)++ = ((v) >> 8) & 0xFF; \
	*(unsigned char *)(p)++ = ((v) >> 16) & 0xFF; \
	*(unsigned char *)(p)++ = ((v) >> 24) & 0xFF; \
  } while (0)

#define WRITESHORT(p,v) \
  do { \
	*(unsigned char *)(p)++ = (v) & 0xFF; \
	*(unsigned char *)(p)++ = ((v) >> 8) & 0xFF; \
  } while (0)

/* and routines to do the same thing to a file */
extern void fwriteshort(short, FILE *);
extern void fwritelong(long, FILE *);

#endif

/* -------- End Of File ----------------------------------------------- */
