/*
		JAS v1.00							  (c) 1996 NikSoft International
		--------------------------------------------------------------------
		LEXAN.H

		Definition of costant and macros used by the lexical
		analyzer modules.
		This must be included only by the LEXAN.C and INPUTM.C
		modules.

		Wednesday, November 12, 1997	Version 1.00
*/

#ifndef __LEXAN_H
#define __LEXAN_H

#include <ctype.h>

#define EOF_CHAR				-1
#define idechar(x)				((x) == '_' || (x) == '$' || isalpha(x))
#define comment(x)				((x) == ';' || (x) == '#' || (x) == '!')
#define radix(x)				\
	((x) == 'b' || (x) == 'B' || (x) == 'd' || (x) == 'D' || \
	 (x) == 'h' || (x) == 'H' || (x) == 'o' || (x) == 'O' )

/* Scan control flags */
// #define STOP_AT_EOF				0x0001
#define EXPAND					0x0002
#define IGNORE					0x0004

struct macro_t {
	char    *MacroText;
	char    **Parameters;
	int		lines;
};

extern char *yytext;
extern unsigned int	yylen;

struct symbol;		/* Declared in 'symmngr.h' */
extern struct symbol *GetMacroSym();

extern int	input();
extern int	eat_white_space();
extern int	unput(int);
extern int	yylex();

extern unsigned SetScanFlag(unsigned);
extern unsigned UnsetScanFlag(unsigned);
extern void		SetExpr(int);

extern int		SwitchToMacro(struct symbol *, char *);
extern int		SwitchToText(char *, int);
extern int		SwitchToFile(char *);
extern void		RepeatText(char *, int, int);

extern struct symbol *BuildMacro(struct symbol *, char **, char *, int);

#endif

/* -------- End Of File ----------------------------------------------- */
